; Ys (for PC-98(2HD/2DD)/OPN) (C)Falcom p
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0xf000
		USE16
		CPU	186

TITLEP_SEG	EQU	0x2000			; ehCozuZOg
ENDPRG_SEG	EQU	0x3000
MANPR1_SEG	EQU	0x4000
MANPR2_SEG	EQU	0x5000
MDATA_OFFSET	EQU	0x4d00			; MANPR1/MANPR2̋ȃf[^zuItZbg()

start:		cli
		cld
		mov	dx,HOOTFUNC
		mov	al,HF_DISABLE		; hootĂяo֎~
		out	dx,al

		mov	ax,cs
		mov	ss,ax
		mov	sp,0xfffe
		xor	ax,ax
		mov	ds,ax
		mov	byte [0x0b30],0xff	; FMƔ肳(0060:0530)

		; hoot hCoo^
		mov	word [0x7f*4+0],hf_entry
		mov	[0x7f*4+2],cs

		mov	dx,HOOTFUNC		; hootĂяo
		mov	al,HF_ENABLE
		out	dx,al
		sti

mainloop:	mov	ax,0x9801
		int	0x18
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98VX::Play  [hO
; inp8(HOOTPORT) = 1  PC98VX::Play  [h
; inp8(HOOTPORT) = 2  PC98VX::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

hf_entry:	push	ds
		push	es
		pusha
		cld
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	.check
		cmp	al,HP_LOADPLAY
		jz	.play_e
		cmp	al,HP_STOP
		jz	.stop_e
.ed:		popa
		pop	es
		pop	ds
		iret

.play_e:	jmp	.play
.stop_e:	jmp	.stop

.check:		mov	ds,[cs:data_segment]	; t~
		mov	ax,[cs:stop_entry]
		call	ax
		cli
		mov	dx,HOOTPORT+4		; hCo^Cvǂݍ
		in	al,dx			; 00:TITLEP 01:ENDPRG 02:MANPR1 03:MANPR2
		mov	[cs:drivertype],al
		or	al,al			; hCoʂɕ
		jz	.title
		cmp	al,2
		jz	.diska
		ja	.diskb

.ending:	mov	ax,ENDPRG_SEG		; hCo]
		call	.driver_xfer
		mov	ax,cs
		mov	ds,ax
		mov	[data_segment],ds
		mov	word [stop_entry],0x1392
		mov	dx,HOOTPORT+5		; Ȕԍwǂݍ
		in	al,dx
		mov	[0x1554],al		; Ȕԍ
		mov	ax,0x0985		; ݏ
		call	ax
		mov	ax,0x0fd7		; tJn
		call	ax
		jmp	short .ed

.title:		mov	ax,TITLEP_SEG		; hCo]
		call	.driver_xfer
		mov	ax,cs
		mov	ds,ax
		mov	[data_segment],ds
		mov	word [stop_entry],0x0e6c
		mov	ax,0x04ad		; ݏ
		call	ax
		mov	ax,0x0aaf		; tJn
		call	ax
		jmp	short .ed

.diska:		mov	ax,MANPR1_SEG		; hCo]
		call	.driver_xfer
		mov	ax,0x0788		; f[^ZOgݒ
		mov	ds,ax
		mov	[cs:data_segment],ax
		call	.set_mdaddr		; ȃf[^zuAhXhootɒʒm
		mov	word [cs:musnum_addr],0x0f1e
		mov	word [cs:init_entry],0x47bc
		mov	word [cs:play_entry],0x4de5
		mov	word [cs:stop_entry],0x5197
		jmp	short .stop

.diskb:		mov	ax,MANPR2_SEG
		call	.driver_xfer
		mov	ax,0x07c0		; f[^ZOgݒ
		mov	ds,ax
		mov	[cs:data_segment],ax
		call	.set_mdaddr		; ȃf[^zuAhXhootɒʒm
		mov	word [cs:musnum_addr],0x11bf
		mov	word [cs:init_entry],0x418c
		mov	word [cs:play_entry],0x47bb
		mov	word [cs:stop_entry],0x4b6d

.stop:		mov	ds,[cs:data_segment]
		mov	ax,[cs:stop_entry]	; t~
		call	ax
		jmp	.ed

.play:		cmp	byte [cs:drivertype],2	; I[vjO/GfBO͉̎Ȃ
		jc	.ed
		mov	ds,[cs:data_segment]
		mov	bx,[cs:musnum_addr]
		mov	dx,HOOTPORT+5		; Ȕԍwǂݍ
		in	al,dx
		mov	[bx],al			; Ȕԍ
		mov	ax,[cs:init_entry]	; FM݃tbN
		call	ax
		mov	ax,[cs:play_entry]	; tJn
		call	ax
		jmp	.ed

.driver_xfer:	mov	ds,ax			; ̃AhXփhCo]
		mov	ax,cs
		mov	es,ax
		xor	si,si
		mov	di,0x0100
		mov	cx,0xd000/2		; ővOTCY
		rep	movsw			; vO]
		ret

.set_mdaddr:	mov	dx,HOOTCTRL+2		; hootɋȃf[^zuAhXʒm
		xor	ax,ax			; vC}[hAhXw
		out	dx,al
		inc	dx
		inc	dx
		mov	ax,MDATA_OFFSET
		out	dx,ax			; [hItZbgw
		inc	dx
		inc	dx
		mov	ax,ds
		out	dx,ax			; [hZOgw(AX)
		mov	dx,HOOTCTRL
		mov	al,HC_SETADDR		; [hAhXύX
		out	dx,al
		ret

drivertype:	db	0x00		; ݓǂݍ܂ĂhCo^Cv
data_segment:	dw	0x0000		; f[^ZOg
musnum_addr:	dw	0x0000		; ȔԍݒAhX
init_entry:	dw	0x04ad		; ݏGg
play_entry:	dw	0x0aaf		; tJnGg
stop_entry:	dw	0x0e6c		; t~Gg

		ends

